Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4802)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4803)
@@ -406,78 +397,106 @@
 
  CONTAINS
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculation of the plant canopy transpiration rate based on the Jarvis-Stewart
-!> with parametrizations described in Daudet et al. (1999; Agricult. and Forest
-!> Meteorol. 97) and Ngao, Adam and Saudreau (2017;  Agricult. and Forest Meteorol
-!> 237-238). Model functions f1-f4 were adapted from Stewart (1998; Agric.
-!> and Forest. Meteorol. 43) instead, because they are valid for broader intervals
-!> of values. Funcion f4 used in form present in van Wijk et al. (1998;
-!> Tree Physiology 20).
+!> Calculation of the plant canopy transpiration rate based on the Jarvis-Stewart with
+!> parametrizations described in Daudet et al. (1999; Agricult. and Forest Meteorol. 97) and Ngao,
+!> Adam and Saudreau (2017;  Agricult. and Forest Meteorol 237-238). Model functions f1-f4 were
+!> adapted from Stewart (1998; Agric. and Forest. Meteorol. 43) instead, because they are valid for
+!> broader intervals of values. Funcion f4 used in form present in van Wijk et al. (1998; Tree
+!> Physiology 20).
 !>
-!> This subroutine is called from subroutine radiation_interaction
-!> after the calculation of radiation in plant canopy boxes.
+!> This subroutine is called from subroutine radiation_interaction after the calculation of
+!> radiation in plant canopy boxes.
 !> (arrays pcbinsw and pcbinlw).
 !>
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE pcm_calc_transpiration_rate(i, j, k, kk, pcbsw, pcblw, pcbtr, pcblh)
 
 !
-!--  input parameters
+!--  Input parameters
      INTEGER(iwp), INTENT(IN) ::  i, j, k, kk        !< indices of the pc gridbox
+     REAL(wp), INTENT(IN)     ::  pcblw              !< lw radiation in gridbox (W)
      REAL(wp), INTENT(IN)     ::  pcbsw              !< sw radiation in gridbox (W)
-     REAL(wp), INTENT(IN)     ::  pcblw              !< lw radiation in gridbox (W)
+     REAL(wp), INTENT(OUT)    ::  pcblh              !< latent heat from transpiration dT/dt (K/s)
      REAL(wp), INTENT(OUT)    ::  pcbtr              !< transpiration rate dq/dt (kg/kg/s)
-     REAL(wp), INTENT(OUT)    ::  pcblh              !< latent heat from transpiration dT/dt (K/s)
-
-!--  variables and parameters for calculation of transpiration rate
-     REAL(wp)             ::  sat_press, sat_press_d, temp, v_lad
-     REAL(wp)             ::  d_fact, g_b, g_s, wind_speed, evapor_rate
-     REAL(wp)             ::  f1, f2, f3, f4, vpd, rswc, e_eq, e_imp, rad
-     REAL(wp), PARAMETER  ::  gama_psychr = 66.0_wp !< psychrometric constant (Pa/K)
-     REAL(wp), PARAMETER  ::  g_s_max = 0.01        !< maximum stomatal conductivity (m/s)
-     REAL(wp), PARAMETER  ::  m_soil = 0.4_wp       !< soil water content (needs to adjust or take from LSM)
-     REAL(wp), PARAMETER  ::  m_wilt = 0.01_wp      !< wilting point soil water content (needs to adjust or take from LSM)
-     REAL(wp), PARAMETER  ::  m_sat = 0.51_wp       !< saturation soil water content (needs to adjust or take from LSM)
-     REAL(wp), PARAMETER  ::  t2_min = 0.0_wp       !< minimal temperature for calculation of f2
-     REAL(wp), PARAMETER  ::  t2_max = 40.0_wp      !< maximal temperature for calculation of f2
-
-
+
+!--  Variables and parameters for calculation of transpiration rate
+     REAL(wp), PARAMETER ::  gama_psychr = 66.0_wp !< psychrometric constant (Pa/K)
+     REAL(wp), PARAMETER ::  g_s_max = 0.01        !< maximum stomatal conductivity (m/s)
+     REAL(wp), PARAMETER ::  m_soil = 0.4_wp       !< soil water content (needs to adjust or take from LSM)
+     REAL(wp), PARAMETER ::  m_wilt = 0.01_wp      !< wilting point soil water content (needs to adjust or take from LSM)
+     REAL(wp), PARAMETER ::  m_sat = 0.51_wp       !< saturation soil water content (needs to adjust or take from LSM)
+     REAL(wp), PARAMETER ::  t2_min = 0.0_wp       !< minimal temperature for calculation of f2
+     REAL(wp), PARAMETER ::  t2_max = 40.0_wp      !< maximal temperature for calculation of f2
+
+     REAL(wp) ::  d_fact
+     REAL(wp) ::  e_eq
+     REAL(wp) ::  e_imp
+     REAL(wp) ::  evapor_rate
+     REAL(wp) ::  f1
+     REAL(wp) ::  f2
+     REAL(wp) ::  f3
+     REAL(wp) ::  f4
+     REAL(wp) ::  g_b
+     REAL(wp) ::  g_s
+     REAL(wp) ::  rad
+     REAL(wp) ::  rswc
+     REAL(wp) ::  sat_press
+     REAL(wp) ::  sat_press_d
+     REAL(wp) ::  temp
+     REAL(wp) ::  v_lad
+     REAL(wp) ::  vpd
+     REAL(wp) ::  wind_speed
+
+!
 !--  Temperature (deg C)
      temp = pt(k,j,i) * exner(k) - degc_to_k
+!
 !--  Coefficient for conversion of radiation to grid to radiation to unit leaves surface
      v_lad = 1.0_wp / ( MAX( lad_s(kk,j,i), 1.0E-10_wp ) * dx * dy * dz(1) )
+!
 !--  Magnus formula for the saturation pressure (see Ngao, Adam and Saudreau (2017) eq. 1)
 !--  There are updated formulas available, kept consistent with the rest of the parametrization
-     sat_press = 610.8_wp * exp(17.27_wp * temp/(temp + 237.3_wp))
+     sat_press = 610.8_wp * EXP( 17.27_wp * temp / ( temp + 237.3_wp ) )
+!
 !--  Saturation pressure derivative (derivative of the above)
-     sat_press_d = sat_press * 17.27_wp * 237.3_wp / (temp + 237.3_wp)**2
+     sat_press_d = sat_press * 17.27_wp * 237.3_wp / ( temp + 237.3_wp )**2
+!
 !--  Wind speed
-     wind_speed = SQRT( ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) )**2 +            &
-                        ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) )**2 +            &
+     wind_speed = SQRT( ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) )**2 +                                &
+                        ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) )**2 +                                &
                         ( 0.5_wp * ( w(k,j,i) + w(k-1,j,i) ) )**2 )
+!
 !--  Aerodynamic conductivity (Daudet et al. (1999) eq. 14
      g_b = 0.01_wp * wind_speed + 0.0071_wp
+!
 !--  Radiation flux per leaf surface unit
      rad = pcbsw * v_lad
+!
 !--  First function for calculation of stomatal conductivity (radiation dependency)
 !--  Stewart (1988; Agric. and Forest. Meteorol. 43) eq. 17
-     f1 = rad * (1000.0_wp+42.1_wp) / 1000.0_wp / (rad+42.1_wp)
+     f1 = rad * ( 1000.0_wp + 42.1_wp ) / 1000.0_wp / ( rad + 42.1_wp )
+!
 !--  Second function for calculation of stomatal conductivity (temperature dependency)
 !--  Stewart (1988; Agric. and Forest. Meteorol. 43) eq. 21
-     f2 = MAX(t2_min, (temp-t2_min) * MAX(0.0_wp,t2_max-temp)**((t2_max-16.9_wp)/(16.9_wp-t2_min)) / &
-              ((16.9_wp-t2_min) * (t2_max-16.9_wp)**((t2_max-16.9_wp)/(16.9_wp-t2_min))) )
+     f2 = MAX( t2_min, ( temp - t2_min ) * MAX( 0.0_wp, t2_max - temp )**( ( t2_max - 16.9_wp ) /  &
+                                                                           ( 16.9_wp - t2_min ) )  &
+               / ( ( 16.9_wp - t2_min ) * ( t2_max - 16.9_wp )**( ( t2_max - 16.9_wp ) /           &
+                                                                  ( 16.9_wp - t2_min ) ) ) )
+!
 !--  Water pressure deficit
 !--  Ngao, Adam and Saudreau (2017) eq. 6 but with water vapour partial pressure
-     vpd = max( sat_press - q(k,j,i) * hyp(k) / rd_d_rv, 0._wp )
+     vpd = MAX( sat_press - q(k,j,i) * hyp(k) / rd_d_rv, 0._wp )
+!
 !--  Third function for calculation of stomatal conductivity (water pressure deficit dependency)
 !--  Ngao, Adam and Saudreau (2017) Table 1, limited from below according to Stewart (1988)
-!--  The coefficients of the linear dependence should better correspond to broad-leaved trees
-!--  than the coefficients from Stewart (1988) which correspond to conifer trees.
-     vpd = MIN(MAX(vpd,770.0_wp),3820.0_wp)
+!--  The coefficients of the linear dependence should better correspond to broad-leaved trees than
+!--  the coefficients from Stewart (1988) which correspond to conifer trees.
+     vpd = MIN( MAX( vpd, 770.0_wp ), 3820.0_wp )
      f3 = -2E-4_wp * vpd + 1.154_wp
+!
 !--  Fourth function for calculation of stomatal conductivity (soil moisture dependency)
 !--  Residual soil water content
@@ -485,28 +504,37 @@
 !--  TODO - over LSM surface might be calculated from LSM parameters
      rswc = ( m_sat - m_soil ) / ( m_sat - m_wilt )
-!--  van Wijk et al. (1998; Tree Physiology 20) eq. 5-6 (it is a reformulation of eq. 22-23 of Stewart(1988))
-     f4 = MAX(0.0_wp, MIN(1.0_wp - 0.041_wp * EXP(3.2_wp * rswc), 1.0_wp - 0.041_wp))
+!
+!--  van Wijk et al. (1998; Tree Physiology 20) eq. 5-6 (it is a reformulation of eq. 22-23 of
+!--  Stewart(1988))
+     f4 = MAX( 0.0_wp, MIN( 1.0_wp - 0.041_wp * EXP( 3.2_wp * rswc ), 1.0_wp - 0.041_wp ) )
+!
 !--  Stomatal conductivity
 !--  Stewart (1988; Agric. and Forest. Meteorol. 43) eq. 12
 !--  (notation according to Ngao, Adam and Saudreau (2017) and others)
      g_s = g_s_max * f1 * f2 * f3 * f4 + 1.0E-10_wp
+!
 !--  Decoupling factor
 !--  Daudet et al. (1999) eq. 6
-     d_fact = (sat_press_d / gama_psychr + 2.0_wp ) /                        &
-              (sat_press_d / gama_psychr + 2.0_wp + 2.0_wp * g_b / g_s )
+     d_fact = ( sat_press_d / gama_psychr + 2.0_wp ) /                                             &
+              ( sat_press_d / gama_psychr + 2.0_wp + 2.0_wp * g_b / g_s )
+!
 !--  Equilibrium evaporation rate
 !--  Daudet et al. (1999) eq. 4
-     e_eq = (pcbsw + pcblw) * v_lad * sat_press_d /                         &
-                 gama_psychr /( sat_press_d / gama_psychr + 2.0_wp ) / l_v
+     e_eq = ( pcbsw + pcblw ) * v_lad * sat_press_d /                                              &
+            gama_psychr / ( sat_press_d / gama_psychr + 2.0_wp ) / l_v
+!
 !--  Imposed evaporation rate
 !--  Daudet et al. (1999) eq. 5
      e_imp = r_d * pt(k,j,i) * exner(k) / hyp(k) * c_p * g_s * vpd / gama_psychr / l_v
+!
 !--  Evaporation rate
 !--  Daudet et al. (1999) eq. 3
 !--  (evaporation rate is limited to non-negative values)
-     evapor_rate = MAX(d_fact * e_eq + ( 1.0_wp - d_fact ) * e_imp, 0.0_wp)
+     evapor_rate = MAX( d_fact * e_eq + ( 1.0_wp - d_fact ) * e_imp, 0.0_wp )
+!
 !--  Conversion of evaporation rate to q tendency in gridbox
 !--  dq/dt = E * LAD * V_g / (rho_air * V_g)
      pcbtr = evapor_rate * r_d * pt(k,j,i) * exner(k) * lad_s(kk,j,i) / hyp(k)  !-- = dq/dt
+!
 !--  latent heat from evaporation
      pcblh = pcbtr * lv_d_cp  !-- = - dT/dt
@@ -515,12 +543,12 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check data output for plant canopy model
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE pcm_check_data_output( var, unit )
 
-    CHARACTER (LEN=*) ::  unit  !< 
+    CHARACTER (LEN=*) ::  unit  !<
     CHARACTER (LEN=*) ::  var   !<
 
@@ -530,19 +558,17 @@
        CASE ( 'pcm_heatrate' )
 !
-!--       Output of heatrate can be only done if it is explicitely set by cthf,
-!--       or parametrized by absorption of radiation. The latter, however, is
-!--       only available if radiation_interactions are on. Note, these are 
-!--       enabled if land-surface or urban-surface is switched-on. Using 
-!--       radiation_interactions_on directly is not possible since it belongs
-!--       to the radition_model, which in turn depends on the plant-canopy model,
-!--       creating circular dependencies.
-          IF ( cthf == 0.0_wp  .AND. (  .NOT.  urban_surface  .AND.             &
-                                        .NOT.  land_surface ) )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //      &
+!--       Output of heatrate can be only done if it is explicitely set by cthf, or parametrized by
+!--       absorption of radiation. The latter, however, is only available if radiation_interactions
+!--       are on. Note, these are enabled if land-surface or urban-surface is switched-on. Using
+!--       radiation_interactions_on directly is not possible since it belongs to the
+!--       radition_model, which in turn depends on the plant-canopy model, creating circular
+!--       dependencies.
+          IF ( cthf == 0.0_wp  .AND.  ( .NOT. urban_surface .AND. .NOT. land_surface ) )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //                         &
                               'res setting of parameter cthf /= 0.0'
              CALL message( 'pcm_check_data_output', 'PA0718', 1, 2, 0, 6, 0 )
           ENDIF
           unit = 'K s-1'
-    
+
        CASE ( 'pcm_transpirationrate' )
           unit = 'kg kg-1 s-1'
@@ -562,29 +588,28 @@
 
  END SUBROUTINE pcm_check_data_output
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check parameters routine for plant canopy model
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
     SUBROUTINE pcm_check_parameters
-           
+
        IF ( ocean_mode )  THEN
-          message_string = 'plant_canopy = .TRUE. is not allowed in the '//    &
-                           'ocean'
+          message_string = 'plant_canopy = .TRUE. is not allowed in the ocean'
           CALL message( 'pcm_check_parameters', 'PA0696', 1, 2, 0, 6, 0 )
        ENDIF
-           
+
        IF ( canopy_drag_coeff == 0.0_wp )  THEN
-          message_string = 'plant_canopy = .TRUE. requires a non-zero drag '// &
+          message_string = 'plant_canopy = .TRUE. requires a non-zero drag ' //                    &
                            'coefficient & given value is canopy_drag_coeff = 0.0'
           CALL message( 'pcm_check_parameters', 'PA0041', 1, 2, 0, 6, 0 )
        ENDIF
 
-       IF ( ( alpha_lad /= 9999999.9_wp  .AND.  beta_lad == 9999999.9_wp ) .OR.&
-              beta_lad /= 9999999.9_wp   .AND.  alpha_lad == 9999999.9_wp )  THEN
-          message_string = 'using the beta function for the construction ' //  &
-                           'of the leaf area density profile requires '    //  &
+       IF ( ( alpha_lad /= 9999999.9_wp .AND. beta_lad == 9999999.9_wp )  .OR.                     &
+            beta_lad /= 9999999.9_wp  .AND.  alpha_lad == 9999999.9_wp )  THEN
+          message_string = 'using the beta function for the construction ' //                      &
+                           'of the leaf area density profile requires '    //                      &
                            'both alpha_lad and beta_lad to be /= 9999999.9'
           CALL message( 'pcm_check_parameters', 'PA0118', 1, 2, 0, 6, 0 )
@@ -592,7 +617,7 @@
 
        IF ( calc_beta_lad_profile  .AND.  lai_beta == 0.0_wp )  THEN
-          message_string = 'using the beta function for the construction ' //  &
-                           'of the leaf area density profile requires '    //  &
-                           'a non-zero lai_beta, but given value is '      //  &
+          message_string = 'using the beta function for the construction ' //                      &
+                           'of the leaf area density profile requires '    //                      &
+                           'a non-zero lai_beta, but given value is '      //                      &
                            'lai_beta = 0.0'
           CALL message( 'pcm_check_parameters', 'PA0119', 1, 2, 0, 6, 0 )
@@ -600,32 +625,31 @@
 
        IF ( calc_beta_lad_profile  .AND.  lad_surface /= 0.0_wp )  THEN
-          message_string = 'simultaneous setting of alpha_lad /= 9999999.9 '// &
-                           'combined with beta_lad /= 9999999.9 '           // &
-                           'and lad_surface /= 0.0 is not possible, '       // &
-                           'use either vertical gradients or the beta '     // &
-                           'function for the construction of the leaf area '// &
+          message_string = 'simultaneous setting of alpha_lad /= 9999999.9 '//                     &
+                           'combined with beta_lad /= 9999999.9 '           //                     &
+                           'and lad_surface /= 0.0 is not possible, '       //                     &
+                           'use either vertical gradients or the beta '     //                     &
+                           'function for the construction of the leaf area '//                     &
                            'density profile'
           CALL message( 'pcm_check_parameters', 'PA0120', 1, 2, 0, 6, 0 )
-       ENDIF 
+       ENDIF
 
        IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-          message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' // &
-                          ' seifert_beheng'
+          message_string = 'plant_canopy = .TRUE. requires cloud_scheme /= seifert_beheng'
           CALL message( 'pcm_check_parameters', 'PA0360', 1, 2, 0, 6, 0 )
        ENDIF
 
-    END SUBROUTINE pcm_check_parameters 
- 
-
-!------------------------------------------------------------------------------!
+    END SUBROUTINE pcm_check_parameters
+
+
+!--------------------------------------------------------------------------------------------------!
 !
 ! Description:
 ! ------------
 !> Subroutine for averaging 3D data
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE pcm_3d_data_averaging( mode, variable )
 
     CHARACTER (LEN=*) ::  mode    !<
-    CHARACTER (LEN=*) :: variable !<
+    CHARACTER (LEN=*) ::  variable !<
 
     INTEGER(iwp) ::  i            !<
@@ -663,15 +687,16 @@
        END SELECT
 
-    ELSEIF ( mode == 'sum' )  THEN
+    ELSE IF ( mode == 'sum' )  THEN
 
        SELECT CASE ( TRIM( variable ) )
 
           CASE ( 'pcm_heatrate' )
-             IF ( ALLOCATED( pcm_heatrate_av ) ) THEN
+             IF ( ALLOCATED( pcm_heatrate_av ) )  THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
                       IF ( pch_index_ji(j,i) /= 0 )  THEN
                          DO  k = 0, pch_index_ji(j,i)
-                            pcm_heatrate_av(k,j,i) = pcm_heatrate_av(k,j,i) + pcm_heating_rate(k,j,i)
+                            pcm_heatrate_av(k,j,i) = pcm_heatrate_av(k,j,i) +                      &
+                                                     pcm_heating_rate(k,j,i)
                          ENDDO
                       ENDIF
@@ -682,10 +707,11 @@
 
           CASE ( 'pcm_latentrate' )
-             IF ( ALLOCATED( pcm_latentrate_av ) ) THEN
+             IF ( ALLOCATED( pcm_latentrate_av ) )  THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
                       IF ( pch_index_ji(j,i) /= 0 )  THEN
                          DO  k = 0, pch_index_ji(j,i)
-                            pcm_latentrate_av(k,j,i) = pcm_latentrate_av(k,j,i) + pcm_latent_rate(k,j,i)
+                            pcm_latentrate_av(k,j,i) = pcm_latentrate_av(k,j,i) +                  &
+                                                       pcm_latent_rate(k,j,i)
                          ENDDO
                       ENDIF
@@ -696,10 +722,11 @@
 
           CASE ( 'pcm_transpirationrate' )
-             IF ( ALLOCATED( pcm_transpirationrate_av ) ) THEN
+             IF ( ALLOCATED( pcm_transpirationrate_av ) )  THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
                       IF ( pch_index_ji(j,i) /= 0 )  THEN
                          DO  k = 0, pch_index_ji(j,i)
-                            pcm_transpirationrate_av(k,j,i) = pcm_transpirationrate_av(k,j,i) + pcm_transpiration_rate(k,j,i)
+                            pcm_transpirationrate_av(k,j,i) = pcm_transpirationrate_av(k,j,i) +    &
+                                                              pcm_transpiration_rate(k,j,i)
                          ENDDO
                       ENDIF
@@ -713,15 +740,15 @@
        END SELECT
 
-    ELSEIF ( mode == 'average' )  THEN
+    ELSE IF ( mode == 'average' )  THEN
 
        SELECT CASE ( TRIM( variable ) )
 
           CASE ( 'pcm_heatrate' )
-             IF ( ALLOCATED( pcm_heatrate_av ) ) THEN
+             IF ( ALLOCATED( pcm_heatrate_av ) )  THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
                       IF ( pch_index_ji(j,i) /= 0 )  THEN
                          DO  k = 0, pch_index_ji(j,i)
-                            pcm_heatrate_av(k,j,i) = pcm_heatrate_av(k,j,i)                 &
+                            pcm_heatrate_av(k,j,i) = pcm_heatrate_av(k,j,i)                        &
                                                      / REAL( average_count_3d, KIND=wp )
                          ENDDO
@@ -733,10 +760,10 @@
 
           CASE ( 'pcm_latentrate' )
-             IF ( ALLOCATED( pcm_latentrate_av ) ) THEN
+             IF ( ALLOCATED( pcm_latentrate_av ) )  THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
                       IF ( pch_index_ji(j,i) /= 0 )  THEN
                          DO  k = 0, pch_index_ji(j,i)
-                            pcm_latentrate_av(k,j,i) = pcm_latentrate_av(k,j,i)              &
+                            pcm_latentrate_av(k,j,i) = pcm_latentrate_av(k,j,i)                    &
                                                        / REAL( average_count_3d, KIND=wp )
                          ENDDO
@@ -748,10 +775,10 @@
 
           CASE ( 'pcm_transpirationrate' )
-             IF ( ALLOCATED( pcm_transpirationrate_av ) ) THEN
+             IF ( ALLOCATED( pcm_transpirationrate_av ) )  THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
                       IF ( pch_index_ji(j,i) /= 0 )  THEN
                          DO  k = 0, pch_index_ji(j,i)
-                            pcm_transpirationrate_av(k,j,i) = pcm_transpirationrate_av(k,j,i)  &
+                            pcm_transpirationrate_av(k,j,i) = pcm_transpirationrate_av(k,j,i)      &
                                                               / REAL( average_count_3d, KIND=wp )
                          ENDDO
@@ -767,15 +794,14 @@
  END SUBROUTINE pcm_3d_data_averaging
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Description:
 ! ------------
-!> Subroutine defining 3D output variables. 
-!> Note, 3D plant-canopy output has it's own vertical output dimension, meaning
-!> that 3D output is relative to the model surface now rather than at the actual
-!> grid point where the plant canopy is located. 
-!------------------------------------------------------------------------------!
- SUBROUTINE pcm_data_output_3d( av, variable, found, local_pf, fill_value,     &
-                                nzb_do, nzt_do )
+!> Subroutine defining 3D output variables.
+!> Note, 3D plant-canopy output has it's own vertical output dimension, meaning that 3D output is
+!> relative to the model surface now rather than at the actual grid point where the plant canopy is
+!> located.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE pcm_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
 
     CHARACTER (LEN=*) ::  variable !< treated variable
@@ -791,4 +817,5 @@
 
     REAL(wp)     ::  fill_value !< fill value
+
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !< data output array
 
@@ -801,10 +828,8 @@
 !
 !--    Note, to save memory arrays for heating are allocated from 0:pch_index.
-!--    Thus, output must be relative to these array indices. Further, check
-!--    whether the output is within the vertical output range,
-!--    i.e. nzb_do:nzt_do, which is necessary as local_pf is only allocated
-!--    for this index space. Note, plant-canopy output has a separate 
-!--    vertical output coordinate zlad, so that output is mapped down to the 
-!--    surface. 
+!--    Thus, output must be relative to these array indices. Further, check whether the output is
+!--    within the vertical output range, i.e. nzb_do:nzt_do, which is necessary as local_pf is only
+!--    allocated for this index space. Note, plant-canopy output has a separate vertical output
+!--    coordinate zlad, so that output is mapped down to the surface.
        CASE ( 'pcm_heatrate' )
           IF ( av == 0 )  THEN
@@ -891,7 +916,7 @@
     END SELECT
 
- END SUBROUTINE pcm_data_output_3d 
-         
-!------------------------------------------------------------------------------!
+ END SUBROUTINE pcm_data_output_3d
+
+!--------------------------------------------------------------------------------------------------!
 !
 ! Description:
@@ -899,12 +924,14 @@
 !> Subroutine defining appropriate grid for netcdf variables.
 !> It is called from subroutine netcdf.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE pcm_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
 
-     CHARACTER (LEN=*), INTENT(IN)  ::  var         !< 
-     LOGICAL, INTENT(OUT)           ::  found       !< 
-     CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !< 
-     CHARACTER (LEN=*), INTENT(OUT) ::  grid_y      !< 
-     CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !< 
+     CHARACTER (LEN=*), INTENT(IN)  ::  var         !<
+     CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !<
+     CHARACTER (LEN=*), INTENT(OUT) ::  grid_y      !<
+     CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !<
+
+     LOGICAL, INTENT(OUT)           ::  found       !<
+
 
      found  = .TRUE.
@@ -914,5 +941,5 @@
      SELECT CASE ( TRIM( var ) )
 
-        CASE ( 'pcm_heatrate', 'pcm_bad', 'pcm_lad', 'pcm_transpirationrate', 'pcm_latentrate')
+        CASE ( 'pcm_heatrate', 'pcm_bad', 'pcm_lad', 'pcm_transpirationrate', 'pcm_latentrate' )
            grid_x = 'x'
            grid_y = 'y'
@@ -927,62 +954,60 @@
 
  END SUBROUTINE pcm_define_netcdf_grid
- 
- 
-!------------------------------------------------------------------------------!
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Header output for plant canopy model
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE pcm_header ( io )
- 
+
     CHARACTER (LEN=10) ::  coor_chr            !<
-
     CHARACTER (LEN=86) ::  coordinates         !<
     CHARACTER (LEN=86) ::  gradients           !<
     CHARACTER (LEN=86) ::  leaf_area_density   !<
     CHARACTER (LEN=86) ::  slices              !<
- 
-    INTEGER(iwp) :: i                !< 
-    INTEGER(iwp),  INTENT(IN) ::  io !< Unit of the output file
-    INTEGER(iwp) :: k                !<       
- 
+
+    INTEGER(iwp)              ::  i   !<
+    INTEGER(iwp),  INTENT(IN) ::  io  !< Unit of the output file
+    INTEGER(iwp)              ::  k   !<
+
     REAL(wp) ::  canopy_height       !< canopy height (in m)
-    
+
+
     canopy_height = zw(pch_index)
 
-    WRITE ( io, 1 )  canopy_mode, canopy_height, pch_index,                    &
-                       canopy_drag_coeff                                       
-    IF ( passive_scalar )  THEN                                                
-       WRITE ( io, 2 )  leaf_scalar_exch_coeff,                                &
-                          leaf_surface_conc
+    WRITE( io, 1 )  canopy_mode, canopy_height, pch_index, canopy_drag_coeff
+    IF ( passive_scalar )  THEN
+       WRITE( io, 2 )  leaf_scalar_exch_coeff, leaf_surface_conc
     ENDIF
 
 !
-!   Heat flux at the top of vegetation
-    WRITE ( io, 3 )  cthf
-
-!
-!   Leaf area density profile, calculated either from given vertical 
-!   gradients or from beta probability density function.
-    IF (  .NOT.  calc_beta_lad_profile )  THEN
+!-- Heat flux at the top of vegetation
+    WRITE( io, 3 )  cthf
+
+!
+!-- Leaf area density profile, calculated either from given vertical gradients or from beta
+!-- probability density function.
+    IF ( .NOT. calc_beta_lad_profile )  THEN
 
 !      Building output strings, starting with surface value
-       WRITE ( leaf_area_density, '(F7.4)' )  lad_surface
+       WRITE( leaf_area_density, '(F7.4)' )  lad_surface
        gradients = '------'
        slices = '     0'
        coordinates = '   0.0'
-       DO i = 1, UBOUND(lad_vertical_gradient_level_ind, DIM=1)
-          IF  ( lad_vertical_gradient_level_ind(i) /= -9999 ) THEN
-
-             WRITE (coor_chr,'(F7.2)') lad(lad_vertical_gradient_level_ind(i))
+       DO  i = 1, UBOUND( lad_vertical_gradient_level_ind, DIM=1 )
+          IF  ( lad_vertical_gradient_level_ind(i) /= -9999 )  THEN
+
+             WRITE( coor_chr, '(F7.2)' ) lad(lad_vertical_gradient_level_ind(i))
              leaf_area_density = TRIM( leaf_area_density ) // ' ' // TRIM( coor_chr )
 
-             WRITE (coor_chr,'(F7.2)') lad_vertical_gradient(i)
+             WRITE( coor_chr, '(F7.2)' ) lad_vertical_gradient(i)
              gradients = TRIM( gradients ) // ' ' // TRIM( coor_chr )
 
-             WRITE (coor_chr,'(I7)') lad_vertical_gradient_level_ind(i)
+             WRITE( coor_chr, '(I7)' ) lad_vertical_gradient_level_ind(i)
              slices = TRIM( slices ) // ' ' // TRIM( coor_chr )
 
-             WRITE (coor_chr,'(F7.1)') lad_vertical_gradient_level(i)
+             WRITE( coor_chr, '(F7.1)' ) lad_vertical_gradient_level(i)
              coordinates = TRIM( coordinates ) // ' '  // TRIM( coor_chr )
           ELSE
